function E = preprocess_detector(D)

if isempty(D.tree)
    E.opts = D.opts;
    return;
end

for i = 1:numel(D.tree)
    T = D.tree{i};
    tp = int32(horzcat(T.tp)');
    for j = 1:numel(T)
        if isempty(T(j).split), T(j).split = zeros(1,7); end;
    end
    split = single(vertcat(T.split)');
    children = int32(horzcat(T.children)');
    prob = single(horzcat(T.p)');
    E.tp(1:size(tp,1),i) = tp;
    E.split(:,1:size(split,2),i) = split;
    E.children(1:size(children,1),i) = children(:,1) - 1;
    E.prob(1:size(prob,1),i) = prob;
end

E.opts = D.opts;
E.split_params = D.split_params;
E.thr = single(D.tau);
E.dims = int32(D.opts.modelDsPad/D.opts.pPyramid.pChns.shrink);
E.split(1:6,:,:) = E.split(1:6,:,:) - 1;
E.split(1,size(E.tp,1),1) = 0;
E.n_stages = int32(numel(D.tree));
%cumstg = cumsum(D.stg);
%stgspan = [[0, cumstg(1:end-1)]+1; cumstg] - 1;
%E.stg_start = int32(stgspan(1,:));
%E.stg_end = int32(stgspan(2,:));

if isfield(D, 'pose_model')
    E.pose_model = D.pose_model;
    E.pose_model.V = single(E.pose_model.V);
end

sp = D.split_params{1}{1};
switch sp
    case {'cmp1'}
        E.splittp = 0;
    case {'diff'}
        E.splittp = 1;
    case {'npd'}
        E.splittp = 2;
end