% img_p - kde na obrazku je auto (stred bb)
% mid_p - kde sa maju vykreslit osy
function [yaw, pitch] = draw_pose(img_p, mid_p, V, lw, scale, focal, pp)
    
    yaw_init = atan((img_p(1) - pp(1))/focal);
    pitch_init = atan((img_p(2) - pp(2))/focal);

    V = normr(V);
    pitch = asin(V(:,3)) - pitch_init;
    yaw = atan2(V(:,2), V(:,1)) + yaw_init;
    [pitch, yaw];
   
    A = [-sin(-yaw), sin(-pitch)*cos(-yaw), cos(-pitch)*cos(-yaw)]*scale;
    B = [cos(-yaw), sin(-pitch)*sin(-yaw),cos(-pitch)*sin(-yaw)]*scale;
    C = [0, cos(-pitch), -sin(-pitch)]*scale;
   
    norm_img_p = img_p - pp;
    P = [A;B;C] + [norm_img_p, focal; norm_img_p, focal; norm_img_p, focal];
    P = bsxfun(@rdivide, P(:,1:2), P(:,3))*focal - [norm_img_p; norm_img_p; norm_img_p];
    
    %acos(normr(A)*normr([0,0,focal])')/pi*180
    %acos(normr(B)*normr([0,0,focal])')/pi*180
    %acos(normr(C)*normr([0,0,focal])')/pi*180
    
    %acos(normr(A)*normr([mid_p] - [pp,0])')/pi*180
    %acos(normr(B)*normr([mid_p] - [pp,0])')/pi*180
    %acos(normr(C)*normr([mid_p] - [pp,0])')/pi*180
    
    %plot([mid_p(1), mid_p(1)+P(1,1); mid_p(1), mid_p(1)+P(2,1); mid_p(1), mid_p(1)+P(3,1)]', [mid_p(2), mid_p(2)+P(1,2); mid_p(2), mid_p(2)+P(2,2); mid_p(2), mid_p(2)+P(3,2)]','-','Color',col,'linewidth',lw);
    

    %plot(Vx(1), Vx(2),'o','Color',col,'linewidth',lw);
   hold on;
    plot([mid_p(1)-P(1,1), mid_p(1)+P(1,1)], [mid_p(2)-P(1,2), mid_p(2)+P(1,2)],'r-','linewidth',lw);
    plot([mid_p(1)-P(2,1), mid_p(1)+P(2,1)], [mid_p(2)-P(2,2), mid_p(2)+P(2,2)],'g-','linewidth',lw);
    plot([mid_p(1)-P(3,1), mid_p(1)+P(3,1)], [mid_p(2)-P(3,2), mid_p(2)+P(3,2)],'b-','linewidth',lw);
    %%{
    plot(mid_p(1)+P(1,1), mid_p(2)+P(1,2),'rd','linewidth',lw);
    plot(mid_p(1)+P(2,1), mid_p(2)+P(2,2),'gd','linewidth',lw);
    plot(mid_p(1)+P(3,1), mid_p(2)+P(3,2),'bd','linewidth',lw);
    %}
    plot(mid_p(1), mid_p(2), 'wo','linewidth',lw);
end