function [splits,M] = pixel_split_eval(X, ind, F, tp)

[u,v,w,~] = size(X);
sz = [u,v,w];

px_i = sub2ind(sz, F(:,1), F(:,2), F(:,5))';
px_j = sub2ind(sz, F(:,3), F(:,4), F(:,6))';
t = F(:,7)';

switch tp
    case {'diff'}
        fSplit = @minus;
    case {'npd'}
        fSplit = @(x,y) (x-y)./(x+y);
    case {'cmp1'}
        fSplit = @(x,y) x;
    otherwise
        error('Unknown split type');
end

%{
splits = false(numel(ind), size(F,1));
if nargout == 2, M = zeros(numel(ind), size(F,1), 'single'); end;

for i = 1:length(ind)
    j = ind(i);
    x = X(:,:,:,j);
    m = fSplit(x(px_i), x(px_j));
    m(~isfinite(m)) = 0;
    splits(i,:) = m > t;
    if nargout == 2, M(i,:) = m; end;
end
%}

%%{
stride = prod(sz);
seq = repmat((0:stride:(numel(X)-1))', 1, size(F,1));
seq = seq(ind,:);
is = bsxfun(@plus, seq, px_i);
js = bsxfun(@plus, seq, px_j);
M = fSplit(X(is), X(js));
splits = bsxfun(@gt, M, t);
%}